VERSION 5.00
Begin VB.Form TalkForm 
   Caption         =   "WinSock-Demo: Talk-Client"
   ClientHeight    =   4455
   ClientLeft      =   9480
   ClientTop       =   1065
   ClientWidth     =   5805
   LinkTopic       =   "Form1"
   ScaleHeight     =   4455
   ScaleWidth      =   5805
   Begin VB.CommandButton C_Send 
      Caption         =   "Senden"
      Height          =   285
      Left            =   4560
      TabIndex        =   5
      Top             =   480
      Width           =   1095
   End
   Begin VB.TextBox T_Text 
      Height          =   285
      Left            =   720
      TabIndex        =   4
      Top             =   480
      Width           =   3735
   End
   Begin VB.CommandButton C_Connect 
      Caption         =   "Connect"
      Default         =   -1  'True
      Height          =   285
      Left            =   4560
      TabIndex        =   2
      Top             =   120
      Width           =   1095
   End
   Begin VB.TextBox T_Server 
      Height          =   285
      Left            =   720
      TabIndex        =   1
      Text            =   "localhost:3000"
      Top             =   120
      Width           =   3735
   End
   Begin VB.ListBox L_Protokoll 
      Height          =   3420
      IntegralHeight  =   0   'False
      Left            =   120
      TabIndex        =   6
      TabStop         =   0   'False
      Top             =   960
      Width           =   5535
   End
   Begin VB.Label Label2 
      Caption         =   "Text:"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   525
      Width           =   615
   End
   Begin VB.Label Label1 
      Caption         =   "Server:"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   165
      Width           =   855
   End
End
Attribute VB_Name = "TalkForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private WithEvents Client As CSocket
Attribute Client.VB_VarHelpID = -1

Private Sub C_Connect_Click()

If C_Connect.Caption = "Connect" Then
   Host$ = Left$(T_Server.Text, InStr(T_Server.Text, ":") - 1)
   Port& = Val(Mid$(T_Server.Text, InStr(T_Server.Text, ":") + 1))
   
   Screen.MousePointer = 11
   L_Protokoll.Clear
   C_Connect.Enabled = False
   
   'jetzt connect initiieren
   Client.Connect Host$, Port&
   
   'und auf Rckmeldung warten
   Do While Client.State = sockConnecting: DoEvents: Loop
   
   Screen.MousePointer = 0
   C_Connect.Enabled = True
   
   If Client.State <> sockConnected Then
      L_Protokoll.AddItem "cannot connect"
   End If
Else
   Client.Disconnect
End If
controlsenable

End Sub

Private Sub C_Send_Click()

L_Protokoll.AddItem "< " + T_Text.Text
L_Protokoll.TopIndex = L_Protokoll.ListCount - 1

Client.SendData T_Text.Text

T_Text.SelStart = 0
T_Text.SelLength = Len(T_Text.Text)

End Sub

Private Sub Form_Load()

Set Client = New CSocket
Client.LineSeparator = vbCrLf
controlsenable

End Sub

Private Sub Form_Resize()

If Me.WindowState = 1 Then Exit Sub
If Me.ScaleWidth - C_Connect.Width - 120 > T_Server.Left + 240 Then C_Connect.Left = Me.ScaleWidth - C_Connect.Width - 120
If Me.ScaleWidth - C_Send.Width - 120 > T_Text.Left + 240 Then C_Send.Left = Me.ScaleWidth - C_Send.Width - 120
If C_Connect.Left - T_Server.Left > 120 Then T_Server.Width = C_Connect.Left - T_Server.Left - 120
If C_Send.Left - T_Text.Left > 120 Then T_Text.Width = C_Send.Left - T_Text.Left - 120
If Me.ScaleWidth > 240 Then L_Protokoll.Width = Me.ScaleWidth - 240
If Me.ScaleHeight - L_Protokoll.Top > 120 Then L_Protokoll.Height = Me.ScaleHeight - L_Protokoll.Top - 120

End Sub

Private Sub Form_Unload(Cancel As Integer)

Client.Disconnect
Set Client = Nothing

End Sub

Sub controlsenable()

If Client.State = sockConnected Then C_Connect.Caption = "Disconnect" Else C_Connect.Caption = "Connect"
Label1.Enabled = Client.State <> sockConnected
Label2.Enabled = Client.State = sockConnected
C_Send.Enabled = Client.State = sockConnected
T_Server.Enabled = Client.State <> sockConnected
T_Text.Enabled = Client.State = sockConnected

C_Send.Default = Client.State = sockConnected
C_Connect.Default = Client.State <> sockConnected

If Me.Visible Then
   If Client.State = sockConnected Then T_Text.SetFocus Else T_Server.SetFocus
End If

End Sub

Private Sub Client_LineDataArrival(LineData As String, RemoteHostIP As String)

'oder:
'Event Client_DataArrival(BinData() As Byte, RemoteHostIP As String)
'... StrConv(BinData, vbUnicode) ...

L_Protokoll.AddItem "> " + LineData
L_Protokoll.TopIndex = L_Protokoll.ListCount - 1

End Sub

Private Sub Client_Closed()

Client.Disconnect
controlsenable

End Sub

