VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "HttpConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

Private WWWProxy As HttpProxy
Attribute WWWProxy.VB_VarHelpID = -1
Private WithEvents Client As CSocket
Attribute Client.VB_VarHelpID = -1
Private WithEvents Server As CSocket
Attribute Server.VB_VarHelpID = -1

Private firstline_received%
Private request$

Private Sub Class_Initialize()
Set Client = New CSocket
Client.LineSeparator = vbCrLf
Set Server = New CSocket
firstline_received% = False
End Sub

Public Sub Accept(WWW As HttpProxy, Proxy As CSocket)
Client.Accept Proxy
Set WWWProxy = WWW
End Sub

Private Sub Client_Closed()
Server.Disconnect
Set Client = Nothing
For n% = 1 To WWWProxy.Clients.Count
   If WWWProxy.Clients(n%) Is Me Then WWWProxy.Clients.Remove n%: Exit For
Next
End Sub

Private Sub Client_LineDataArrival(LineData As String, RemoteHostIP As String)
   
If Not firstline_received% Then
   request$ = LineData
   
   'Url zerlegen
   methode$ = parse$(LineData, " http://")
   hostport$ = parse$(LineData, "/"): host$ = parse$(hostport$, ":"): Port& = Val(hostport$): If Port& = 0 Then Port& = 80
   url$ = parse$(LineData, " ")
   http$ = LineData
   WWWProxy.Log LogEntry$()
   
   'Zielrechner kontaktieren
   Server.Connect host$, Port&
   Do While Server.state = sockConnecting: DoEvents: Loop
   If Server.state <> sockConnected Then
      'Fehlerantwort senden
      If Len(http$) Then
         Client.SendData "HTTP/1.0 200 ok"
         Client.SendData "Content-type: text/plain"
         Client.SendData ""
      End If
      Client.SendData "cannot connect server:"
      Client.SendData host$ & ":" & Port&
      Client.Disconnect
   Else
      Server.SendData Trim$(methode$ + " /" + url$ + " " + http$) + vbCrLf
   End If
   firstline_received% = True
ElseIf Server.state = sockConnected Then
   Server.SendData LineData + vbCrLf
End If

End Sub

Private Function LogEntry$()

LogEntry$ = Client.RemoteHost & " -  - [" & Mid$(Date$, 4, 2) & "/" & Mid$("JanFebMarAprMayJunJulAugSepOctNovDec", Val(Left$(Date$, 2)) * 3 - 2, 3) & "/" & Mid$(Date$, 7) & ":" & Time$ & "] """ & request$ + """"

End Function

Private Function parse$(a$, ch$)

ai% = InStr(a$, ch$)
If ai% = 0 Then
  parse$ = a$: a$ = ""
Else
  parse$ = Left$(a$, ai% - 1): a$ = Mid$(a$, ai% + Len(ch$))
End If

End Function

Private Sub Server_Closed()
Client.Disconnect
End Sub

Private Sub Server_DataArrival(BinData() As Byte, RemoteHostIP As String)
Client.SendData BinData
End Sub

